function [s,t, q, z]= qzzero(s,t,q,z);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% This program takes upper triangular matrices s and t and orthornormal matrices 
% q and z. It drives all the zero elements on the diagonal of t to the bottom 
% right while keeping q'sz' and q'tz' unchanged
%
% The program uses qzswitch by Chris Sims, see
% http://eco-072399b.princeton.edu/yftp/gensys/mfiles/QZSWITCH.M
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Andreas Beyer and Roger E. A. Farmer
% February 2004
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
eps=1E-10;
n=size(s,1);
td=diag(t);
numzeros=sum(abs(td)<eps);

while sum(abs(td(n-numzeros+1:n))>eps)>0;
  i=1;
    while i<n;
        if  and(abs(t(i,i))<eps,abs(t(i+1,i+1))>eps);
            [s,t,q,z]=qzswitch(i,s,t,q,z);
            td=diag(t);
            i=i+1;
        else
            i=i+1;
        end
    end
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  END %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

